git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Max Kirillov <max@max630.net>
To: Carlo Arenas <carenas@gmail.com>, git@vger.kernel.org
Cc: Max Kirillov <max@max630.net>, peff@peff.net
Subject: [PATCH] t5562: do not reuse output files
Date: Sat, 24 Nov 2018 09:04:28 +0200	[thread overview]
Message-ID: <20181124070428.18571-1-max@max630.net> (raw)
In-Reply-To: <CAPUEspi67=Kt=mx21bjG2oCATnU+byO5nkvbMdQkN03yBGZMsA@mail.gmail.com>

Some expected failures of git-http-backend leave running its children
(receive-pack or upload-pack) which still hold opened descriptors
to act.err and with some probability they live long enough to write
their failure messages after next test has already truncated
the files. This causes occasional failures of the test script.

Avoid the issue by unlinking the older files before writing to them.

Reported-by: Carlo Arenas <carenas@gmail.com>
Helped-by: Carlo Arenas <carenas@gmail.com>
Signed-off-by: Max Kirillov <max@max630.net>
---
Thanks for the analysis. I seem to have guessed the reason.
This patch should prevent it.

I think the tests should somehow make sure there are no such late
processes. I can see 2 options:
* somehow find out in the tests all children and wait for them. I have no idea how.
* make http-backend close handle to its child and wait for it to exit before dying.
  This would not prevent childrenc in general, because http-backend may be killed,
  but not in our expected failure cases

Actually, don't the children receive some SIGHUP? Maybe thy should. However, it
would still take some time for them to handle it, so it does not fully solve the issue
 t/t5562-http-backend-content-length.sh | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/t/t5562-http-backend-content-length.sh b/t/t5562-http-backend-content-length.sh
index 90d890d02f..bb53f82c0c 100755
--- a/t/t5562-http-backend-content-length.sh
+++ b/t/t5562-http-backend-content-length.sh
@@ -25,6 +25,8 @@ test_http_env() {
 	handler_type="$1"
 	request_body="$2"
 	shift
+	(rm -f act.out || true) &&
+	(rm -f act.err || true) &&
 	env \
 		CONTENT_TYPE="application/x-git-$handler_type-pack-request" \
 		QUERY_STRING="/repo.git/git-$handler_type-pack" \
@@ -155,6 +157,8 @@ test_expect_success 'CONTENT_LENGTH overflow ssite_t' '
 '
 
 test_expect_success 'empty CONTENT_LENGTH' '
+	(rm -f act.out || true) &&
+	(rm -f act.err || true) &&
 	env \
 		QUERY_STRING="service=git-receive-pack" \
 		PATH_TRANSLATED="$PWD"/.git/info/refs \
-- 
2.19.0.1202.g68e1e8f04e


  reply	other threads:[~2018-11-24  7:04 UTC|newest]

Thread overview: 35+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-11-19 10:15 [PATCH] t5562: skip if NO_CURL is enabled Carlo Marcelo Arenas Belón
2018-11-19 10:42 ` Ævar Arnfjörð Bjarmason
2018-11-19 18:40 ` Max Kirillov
2018-11-19 19:36   ` Carlo Arenas
2018-11-19 21:26     ` Max Kirillov
2018-11-19 21:39       ` Jeff King
2018-11-22 23:38         ` [PATCH] t5562: fix perl path Max Kirillov
2018-11-23 14:31           ` Carlo Arenas
2018-11-24 12:10           ` Jeff King
2018-11-20  9:11     ` [PATCH] t5562: skip if NO_CURL is enabled Jeff King
2018-11-21 12:02       ` Carlo Arenas
2018-11-21 22:49         ` Max Kirillov
2018-11-21 23:36           ` Carlo Arenas
2018-11-22  1:04           ` Carlo Arenas
2018-11-22  6:37             ` Max Kirillov
2018-11-22 10:17               ` Carlo Arenas
2018-11-22 16:17                 ` Jeff King
2018-11-22 23:43                   ` Max Kirillov
2018-11-23 12:57                     ` Carlo Arenas
2018-11-24  7:04                       ` Max Kirillov [this message]
2018-11-24  7:34                         ` [PATCH] t5562: do not reuse output files Junio C Hamano
2018-11-24  7:47                           ` Junio C Hamano
2018-11-24  7:58                             ` Max Kirillov
2018-11-24  9:37                             ` [PATCH v3] " Max Kirillov
2018-11-24 12:14                             ` [PATCH] " Jeff King
2018-11-24 13:03                             ` Max Kirillov
2018-11-24 13:48                               ` [PATCH] http-backend: enable cleaning up forked upload/receive-pack on exit Max Kirillov
2018-11-26  2:10                                 ` Junio C Hamano
2018-11-26  2:06                               ` [PATCH] t5562: do not reuse output files Junio C Hamano
2018-11-28  4:17                                 ` Max Kirillov
2018-11-24  7:52                           ` [PATCH v2] " Max Kirillov
2018-11-28 14:56                   ` [PATCH] t5562: skip if NO_CURL is enabled Ævar Arnfjörð Bjarmason
2018-12-01 19:53                     ` Jeff King
2018-11-28 13:27       ` SZEDER Gábor
2018-12-01 19:50         ` Jeff King

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20181124070428.18571-1-max@max630.net \
    --to=max@max630.net \
    --cc=carenas@gmail.com \
    --cc=git@vger.kernel.org \
    --cc=peff@peff.net \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).